/* PCF.h */

/*
    NUT nutrition software 
    Copyright (C) 1996-2012 by Jim Jozwiak.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef PCF_H
#define PCF_H

#include <FL/Fl_Pack.H>
#include <FL/Fl_Light_Button.H>
#include "ViewFoods.h"
#include "MealFood.h"

class MealFood;

void clear_out_pcfs(void);

class PCF : public Fl_Pack
{
public:
PCF(int x, int y, int w, int h, Fl_Color widgetcolor, MealFood *mf);
void only_one(Fl_Light_Button *button);
void update_PCF_matrix(void);
void update_PCF_matrix_without_computation(void);
void update_PCF_matrix_except_yourself(void);
void gram_change(int index, double newvalue);
static void refresh_values(void);
static void dv_change(void);
static void PCF_computation(void);
Fl_Light_Button *p, *c, *f;

private:
MealFood *mf;
};

#endif
